<template>
    <div class="inline-help">
        <span class="help" @click="help" @mouse.enter="help" @mouse.leave="hideHelp"></span>
        <transition name="slide">
            <div class="help-text" v-show="display" :style="style">
                <span class="close" @click="close"></span>
                <slot></slot>
            </div>
        </transition>
    </div>
</template>

<script>
  export default {
    name: 'ui-inline-help',
    data () {
      return {
        display: false,
        style: {}
      }
    },
    methods: {
      help (e) {
        console.log(e)
        this.display = true
        document.addEventListener('click', this.clickHandler, false)
      },

      hideHelp () {
        this.display = false
        document.removeEventListener('click', this.clickHandler, false)
      },

      close () {
        this.display = false
        document.removeEventListener('click', this.clickHandler, false)
      },

      clickHandler (e) {
        if (!e.target.classList.contains('help-text') && e.target.closest('.inline-help') === null) {
          this.display = false
        }
      }
    }
  }
</script>

<style scoped lang="scss">

    .inline-help {
        margin-left:5px;
        cursor: pointer;
        display: inline-block;
        width: 18px;
        height: 18px;
        & span.help {
            background: url(/lk/static/img/head/content/tooltip.png) no-repeat;
            width: 100%;
            height: 100%;
            display: block;
            top: 3px;
            position: relative;
        }

        & .help-text {
            z-index: 999;
            width: 100%;
            max-width: 500px;
            height: auto;
            min-height: 60px;
            position: absolute;
            background: #fff;
            border-radius: 7px;
            border: 1px solid #efefef;
            text-transform: none;
            font-size:12px;
            font-weight: normal;
            padding: 10px 20px;
            padding-right: 40px;
            box-shadow: 0 2px 12px 0 rgba(0,0,0,.1);
            line-height: 16px;

            & span.close {
                display: block;
                width: 18px;
                height: 18px;
                background: url(/lk/static/img/lk/icons/close-big.png) no-repeat;
                position: absolute;
                right: 9px;
                background-size: 12px;
            }
        }
    }
    @media all and(max-width: 600px) {
        .inline-help {
            .help-text {
                position: absolute;
                left: 20px;
                right: 20px;
                width: calc(100% - 40px);
            }
        }
    }

</style>